;****************************************************************************************
;		Rotinas para trasmissao de AX.25
;****************************************************************************************

ax25

;------ 
	btfsc	RX_detect		;verifica se o squelch esta' aberto
	 goto	$-1
	call	del_1			;espera 1seg e verifica outra vez
	btfsc	RX_detect		;verifica se o squelch esta' aberto
	 goto	ax25
;------ 

	call	Tone_Disable		; setup the packet system
	
mainLoop
	call	Packet_Start		; start sending a packet  MANDA INDICATIVOS E PATH
	
	clrf	index
message_loop				;MANDA DADOS METEOROLOGICOS
	movf	index, w
	call	Get_Message_Char	; send the message
	iorlw	0
	skpnz
	 goto	$+4			; until we get a zero
	call	Packet_Send
	incf	index, F		; bump to next char
	goto	message_loop

;----------------------------------------------------------------------

	clrf	index
message_loop_previsao			;MANDA A PREVISAO METEOROLOGICA em texto
	movf	temp_indoor_7, w
	sublw	0x02			;nublado
	btfsc	status, z		;sim ??
	 goto	_nublado

	movf	temp_indoor_7, w
	sublw	0x03			;chuva
	btfsc	status, z		;sim ??
	 goto	_chuva0
	
	movf	temp_indoor_7, w
	sublw	0x06			;pouco nublado
	btfsc	status, z		;sim ??
	 goto	_pouco_nublado

	movf	temp_indoor_7, w
	sublw	0x0c			;ceu limpo
	btfsc	status, z		;sim ??
	 goto	_ceu_limpo

	goto	message_loop_error_index


_nublado
	movf	index, w
	call	Get_Message_nublado	; send the message
	goto	_resto

_chuva0	movf	index, w
	call	Get_Message_chuva	; send the message
	goto	_resto

_pouco_nublado
	movf	index, w
	call	Get_Message_pouco_nublado	; send the message
	goto	_resto

_ceu_limpo
	movf	index, w
	call	Get_Message_ceu_limpo	; send the message

_resto	iorlw	0
	skpnz
	 goto	$+4			; until we get a zero
	call	Packet_Send
	incf	index, F		; bump to next char
	goto	message_loop_previsao

;----------------------------------------------------------------------
message_loop_error_index
	clrf	index			;limpa contador q corre o acesso 'as tramas
message_loop_erro
	movf	flag_erro, f		;ha' erros ??
	btfsc	status, z		;sim
	 goto	message_done		;nao, acaba trama

	movf	index, w
	call	Get_Message_erro	; send the message
	iorlw	0
	skpnz
	 goto	message_done		; until we get a zero
	call	Packet_Send
	incf	index, F		; bump to next char
	goto	message_loop_erro

;----------------------------------------------------------------------

message_done		
	call	Packet_End		; complete the packet

	reset_a_0_dos_valores_wx	;faz a limpeza e espera dados novos   LINHA INSERIDA NOVAMENTE
					;					P TENTAR EVITAR PROBS DE VENTO
	return				;end APRS packet burst



















;****************************************************************************************
;****************************************************************************************
;****************************************************************************************
;****************************************************************************************

Packet_Start
	bsf	PTT_OUT			; press PTT
	bcf	MODEB_OUT		; enable audio tone
	bsf	MODEA_OUT		; enable audio tone

	movlw	TX_DELAY		; get initial flag count
	movwf	packet_temp
Packet_Start_Flag_Loop
	call	Packet_Flag		; send the initial flags
	decfsz	packet_temp, F
	 goto	Packet_Start_Flag_Loop

	movlw	H'FF'			; crc inits to 0xFFFF
	movwf	packet_crc_hi
	movwf	packet_crc_lo

Packet_Send_Header			; send the header
	movf	packet_temp, w
	call	Get_Header
	iorlw	0			; until we get a 0
	skpnz				; then return
	 goto	Packet_Send_final_header

					;rotina para ver se funciona sem o <<1 nas tabelas
	movwf	temp2			;23.12.00
	incf	packet_temp, W
	call	Get_Header
	iorlw	0
	clrc
	skpnz
	 setc
 	rlf	temp2, W


	call	Packet_Send		; send each byte
	incf	packet_temp, F
	goto	Packet_Send_Header	; and loop back


Packet_Send_final_header

	movlw	H'03'
	call	Packet_Send
	movlw	H'F0'
	call	Packet_Send
	return

;_______________________________________________________________

Packet_End
	movlw	H'FF'			; invert CRC
	xorwf	packet_crc_lo, F	
	xorwf	packet_crc_hi, W	
	movwf	packet_temp		; save hi in temp
	movfw	packet_crc_lo		; send lo
	call	Packet_Send
	movfw	packet_temp		; send hi
	call	Packet_Send
	call	Packet_Flag		; send final flags
	call	Packet_Flag		; send final flags
	call	Packet_Flag		; send final flags
	call	Packet_Flag		; send final flags
Tone_Disable
	bsf	MODEB_OUT		; disable audio tone
	bcf	MODEA_OUT		; disable audio tone
	bcf	TONE_OUT		; disable audio tone
	bcf	PTT_OUT			; release PTT

	return

;_______________________________________________________________

Packet_Send
	movwf	packet_sending_char	; save the char to send
	movlw	8			; send 8 bits
	movwf	packet_sending_count
Packet_Send_Loop
	rrf	packet_sending_char, W	; save bit for CRC
	movlw	1
	skpnc
	 xorwf	packet_crc_lo, F	; crc ^= d & 1;
	clrc
	rrf	packet_crc_hi, F	; crc >>= 1
	rrf	packet_crc_lo, F
	skpc
	 goto	Packet_CRC_Done		; if shifted off 1
	movlw	H'08'			; xor POLY 0x8408
	xorwf	packet_crc_lo, F
	movlw	H'84'
	xorwf	packet_crc_hi, F	
Packet_CRC_Done
	rrf	packet_sending_char, F	; get bit again for sending
 	call	Packet_Send_Bit		; send it
	decfsz	packet_sending_count, F	; continue for all 8 bits
	 goto	Packet_Send_Loop
	return 				; done
;_______________________________________________________________

Packet_Send_Bit
	rlf	packet_bit_history, F	; store the last 8 bits sent
	movlw	D'130'			; bump TMR0 forward forward ** cristal de 10MHz
	subwf	tmr0, F			; 1200 baud updates
	rrf	packet_bit_history, W	; restore the bit
	
	btfss	intcon, 2		; wait for last bit to be sent
	 goto	$-1
	bcf	intcon, 2	 	; clear TMR0 overflow

	movlw	B'00001000' 		;TONE_OUT e' na porta, 3
	skpc				; if sending a 0
	 xorwf	porta, F		; toggle TONE_OUT

	comf	packet_bit_history, W	; check the last 5 bits
	andlw	H'1F'			; for bit stuffing
 	skpz				; if not all 1s
 	 return				; return
	clrc				; send a transparent 0 bit
	goto	Packet_Send_Bit			
;_______________________________________________________________

Packet_Flag				
	movlw	H'7E'			; send a flag 0x7E
	movwf	packet_sending_char
	movlw	8			; send 8 bits
	movwf	packet_sending_count
Packet_Flag_Loop
	rrf	packet_sending_char, F	; get bit for sending
 	call	Packet_Send_Bit		; send it
	clrf	packet_bit_history	; no bit stuffing for flags
	decfsz	packet_sending_count, F	; send all 8 bits
	 goto	Packet_Flag_Loop
	return 				; done

;****************************************************************************************
;****************************************************************************************

