;***********************************************  04.04.2002  ***
;
;	"Interface WMR9x8 para redes APRS"
;
;		Antonio Sergio Sena		copyright 2002
;		CT2GPW
;		www.senaeng.com




	include	"defmacro.asm"

;*************************************************************
;*************************************************************

		org     0x000             ; processor reset vector
		clrf	pclath
		nop
		nop
		goto	start
	
		org	0x004
		goto	interrupt_routine

	include	"tabelas.asm"

;**************************************************************************************************
;       inicio de programa
;**************************************************************************************************
start	clrf	porta
	movlw	0x07			;disable comparadores
	movwf	cmcon
	bank1				;bank1
	movlw	0x20			;detecao de squelch aberto
	movwf	trisa			;
	movlw	0x0a			;entrada RS232 e beacon forado
	movwf	trisb			;para ja', so' saidas
	movlw   b'00000011'		;prescaler for 16 for 1200bps, ax.25 code use only
	movwf   options 
	movlw	b'00000100'		;TX off, High Speed baud rate
	movwf	txsta			;transmit status and control register
	movlw	.64			;baudrate generator for 9600bps
	movwf	spbrg
	movlw	0x21
	movwf	pie1			;TMR1 e USART
	bank0				;bank0
 
	movlw	b'11000000'		;enable global, peripheral
	movwf	intcon			;

	movlw	b'10010000'	
	movwf	rcsta			;receive status and control register

	movlw	0x31
	movwf	t1con			; TMR1 -> 1:8 prescaler, internal, enabled tmr1

;------------------------------------------------------------------------
	limpar_ram			;limpa RAM ate' 0x7f
	reset_a_0_dos_valores_wx	;so' dos registos de WX
;------------------------------------------------------------------------

	movlw	.1			;apenas 1, pq qd carregar outra vez, vai ser com 28
	movwf	cntaprs1		;counters for APRS delay
	movlw	.11			;perfaz +- 60segs
	movwf	cntaprs2
	bcf	pir1, tmr1if		;clear TMR1 overflow
	clrf	tmr1l
	clrf	tmr1h


main	btfsc	beacon_forcado		;botao premido ??
	goto	$-1

					;MANDA BEACON

	clrf	intcon			;desliga interrupoes
	clrf	rcsta			;disable USART, enquanto esta' dentro da interrupao TMR1

	call	ax25			;manda pacote

	movlw	.28			;7-5mins   14-10mins   28-20mins		10MHz cristal
	movwf	cntaprs1
	movlw	.200			;200 helps to get 5mins
	movwf	cntaprs2

	bcf	pir1, tmr1if		;clear TMR1 overflow
	clrf	tmr1l
	clrf	tmr1h
	movlw	b'10010000'	
	movwf	rcsta			;enable USART (evita bloqueamento da mesma, qd o Buffer de RX esta' cheio)
	movlw	b'11000000'		;enable global, peripheral
	movwf	intcon			;

					;BEACON MANDADO E REGISTOS, de novo, CARREGADOS

	goto	main



;*********************************************************************

dir_100	movf	direccao_cem, w
	return
dir_10	movf	direccao_dez, w
	return
dir_1	movf	direccao_um, w
	return
velo_100
	movf	velocidade_cem, w
	return
velo_10	movf	velocidade_dez, w
	return
velo_1	movf	velocidade_um, w
	return
pico_100	
	movf	pico_cem, w
	return
pico_10	movf	pico_dez, w
	return
pico_1	movf	pico_um, w
	return
temp_100
	movf	temperatura_cem, w
	return
temp_10	movf	temperatura_dez, w
	return
temp_1	movf	temperatura_um, w
	return
chuva_100
	movf	chuva_cem, w
	return
chuva_10
	movf	chuva_dez, w
	return
chuva_1	movf	chuva_um, w
	return
hid_10	movf	humidade_dez, w
	return
hid_1	movf	humidade_um, w
	return
bar_10k	movf	pressao_10k, w
	return
bar_1k	movf	pressao_1k, w
	return
bar_100	movf	pressao_cem, w
	return
bar_10	movf	pressao_dez, w
	return
bar_1	movf	pressao_um, w
	return
_erro	movf	flag_erro, w
	addlw	0x30
	return	

;*********************************************************************

	include	"delays.asm"		;delay routines

	include	"ie.asm"		;interrupt routine

	include	"usart.asm"		;routines to handle GPS data

	include	"ax25.asm"		;packet routines

	include	"math.asm"		;rotinas matematicas

	include	"workdata.asm"		;rotinas de tratamento dos dados recebidos

;*******************************************************************
	fill	(goto	0x000),	0x800 - $
;*******************************************************************

		end			; directive 'end of program'
